Package: Metrics
Version: 0.1.4
Title: Evaluation Metrics for Machine Learning
Description: An implementation of evaluation metrics in R that are commonly
             used in supervised machine learning. It implements metrics for
             regression, time series, binary classification, classification,
             and information retrieval problems. It has zero dependencies and
             a consistent, simple interface for all functions.
Authors@R: c(
    person("Ben", "Hamner", role = c("aut", "cph"), email = "ben@benhamner.com"),
    person("Michael", "Frasco", role = c("aut", "cre"), email = "mfrasco6@gmail.com"),
    person("Erin", "LeDell", role = c("ctb"), email = "oss@ledell.org"))
Maintainer: Michael Frasco <mfrasco6@gmail.com>
Suggests: testthat
URL: https://github.com/mfrasco/Metrics
BugReports: https://github.com/mfrasco/Metrics/issues
License: BSD_3_clause + file LICENSE
RoxygenNote: 6.0.1
NeedsCompilation: no
Packaged: 2018-07-09 03:33:50 UTC; mfrasco
Author: Ben Hamner [aut, cph],
  Michael Frasco [aut, cre],
  Erin LeDell [ctb]
Repository: CRAN
Date/Publication: 2018-07-09 04:30:18 UTC

# Capture

This guide explains how to use `metrics` for exporting metric definitions from your application.

## With Provider Metrics

If your application defines one or more metrics, you can export them using the `bake metrics:document` command. This command will generate a list of metrics which you can export.

```bash
$ cd test/metrics/backend/.capture/
$ bake metrics:capture environment metrics:capture:list output --format json
[
  {
    "name": "my_metric",
    "type": "gauge",
    "description": "My metric",
    "unit": "seconds",
    "values": [

    ],
    "tags": [

    ],
    "sample_rates": [

    ]
  }
]
```

## With Test Suite

If your application has a test suite which emits metrics, you can capture those as samples for the purpose of your documentation. This includes fields like tags.

```bash
$ cd test/metrics/backend/.capture/
$ bake metrics:capture run metrics:capture:list output --format json
[
  {
    "name": "my_metric",
    "type": "gauge",
    "description": "My metric",
    "unit": "seconds",
    "values": [
      1
    ],
    "tags": [
      "environment:test"
    ],
    "sample_rates": [
      1.0
    ]
  }
]
```

This uses a custom task called `run` in the above example, but you should probably consider using `bake test` which runs your test suite.

# performancecopilot.metrics.elasticsearch

Installs and configures [Elasticsearch](https://www.elastic.co/elasticsearch) metrics from the [Performance Co-Pilot](https://pcp.io/) toolkit, and optional exporting of PCP metrics to Elasticsearch.

## Requirements

Uses features of PCP v5.2.1 and later.

## Role Variables

    elasticsearch_agent: yes

Collect metrics from the local Elasticsearch server.

    elasticsearch_agent_port: 9200

Connect on given socket port for Elasticsearch metric collection.

    elasticsearch_agent_authname: ''

Sets the HTTP request username for Elasticsearch metric collection.

    elasticsearch_agent_password: ''

Sets the HTTP request password for Elasticsearch metric collection.

    elasticsearch_export_metrics: no

Enable exporting of PCP metrics metadata and values to Elasticsearch.

    elasticsearch_export_interval: 60

Sets the sampling interval for exporting metric values to Elasticsearch, in seconds.

    elasticsearch_export_server: 'http://localhost:9200'

Elasticsearch server URL for PCP metric metadata and value exporting.

    elasticsearch_export_index: 'pcp'

Elasticsearch index to use for PCP metric names.

    elasticsearch_export_hostid: []

Specify the Elasticsearch host-id for measurements, default is the PCP metrics source hostname.

    elasticsearch_export_type: 'pcp-metric'

Specify the Elasticsearch search type for measurements.

## Dependencies

None.

## Example Playbooks

Make local Elasticsearch metrics available to PCP analysis tools.

```yaml
- hosts: monitoring
  roles:
    - role: performancecopilot.metrics.elasticsearch
      vars:
        elasticsearch_agent_port: 9200
```

Setup export of PCP metrics to a remote Elasticsearch server.

```yaml
- hosts: monitoring
  roles:
    - role: performancecopilot.metrics.elasticsearch
      vars:
        elasticsearch_export_server: 'http://elastic.example.com:9200'
        elasticsearch_export_authname: 'metrics'
        elasticsearch_export_password: 'xxxxxxx'
```

## License

MIT

## Author Information

An official role for PCP, maintained by the PCP developers <pcp@groups.io>

# performancecopilot.metrics.grafana

Installs and configures [Grafana](https://grafana.com) for use with the [Performance Co-Pilot](https://pcp.io/) toolkit.

## Requirements

Uses features of Grafana v6+.  All available PCP datasources will be installed from the [grafana-pcp](https://github.com/performancecopilot/grafana-pcp) package.

## Role Variables

None.

## Dependencies

None.

## Example Playbook

Setup PCP and Grafana for graphing live metrics locally using Vector.

```yaml
- hosts: monitoring
  roles:
    - role: performancecopilot.metrics.grafana
    - role: performancecopilot.metrics.pcp
      vars:
        pcp_rest_api: yes
```

## License

MIT

## Author Information

An official role for PCP, maintained by the PCP developers <pcp@groups.io>

# performancecopilot.metrics.mssql

Installs and configures Microsoft [SQL Server](https://docs.microsoft.com/en-us/sql/) metrics from the [Performance Co-Pilot](https://pcp.io/) toolkit.

## Requirements

Requires a SQL Server 2017 (or later) database server, and Python ODBC software [pyodbc](https://docs.microsoft.com/en-us/sql/connect/python/pyodbc/).  This role does *not* install or configure those components, rather it configures PCP to extract metrics from SQL Server using them.

The SQL Server metrics are available from PCP v5.2 and later.

## Role Variables

    mssql_agent_trusted: yes

Connect to SQL Server using [Windows Authentication mode](https://docs.microsoft.com/en-us/sql/relational-databases/security/choose-an-authentication-mode?view=sql-server-ver15#connecting-through-windows-authentication)

    mssql_agent_username: 'sa'

Connect to SQL server using [SQL Server Authentication mode](https://docs.microsoft.com/en-us/sql/relational-databases/security/choose-an-authentication-mode?view=sql-server-ver15#connecting-through-sql-server-authentication).  This is mutually exclusive with the mssql_agent_trusted authentication mode.

    mssql_agent_password: 'admin'

Sets the pass phrase associated with mssql_agent_username, for use when connecting with SQL Server Authentication mode (only).

    mssql_agent_timeout: 2

Close the connection to SQL Server if a response is not received within this number of seconds.  Subsequent requests will result in attempts to reestablish a connection.

## Dependencies

None.

## Example Playbooks

Setup PCP SQL Server metrics using Windows Authentication mode.

```yaml
- hosts: monitoring
  roles:
    - role: performancecopilot.metrics.mssql
      vars:
        mssql_agent_timeout: 5
```

Setup PCP SQL Server metrics using SQL Server Authentication.

```yaml
- hosts: monitoring
  roles:
    - role: performancecopilot.metrics.mssql
      vars:
        mssql_agent_trusted: no
        mssql_agent_username: sa
        mssql_agent_password: admin
```

## License

MIT

## Author Information

An official role for PCP, maintained by the PCP developers <pcp@groups.io>

# performancecopilot.metrics.spark

Installs and configures [Apache Spark](https://spark.apache.org/) metrics from the [Performance Co-Pilot](https://pcp.io/) toolkit, and optional exporting of PCP metrics to Spark.

## Requirements

Uses features of PCP v5.2.1 and later.

## Role Variables

    spark_metrics_agent: yes

Collect metrics from a Spark executor.

    spark_metrics_agent_url: 'http://localhost:4040/metrics/executors/prometheus'

URL for the Prometheus (OpenMetrics) endpoint in the Spark UI.  This depends on the PrometheusServlet in the Spark UI, which is enabled via configuration parameter: spark.ui.prometheus.enabled=true (the default is false).  This role does not configure Spark itself, only PCP, so this must be already established before this role is used.

    spark_export_metrics: no

Enable exporting of PCP metrics metadata and values to Spark via pcp2spark(1).

    spark_export_interval: 60

Sets the sampling interval for exporting metric values to Spark, in seconds.

    spark_export_server: '127.0.0.1'

Address on which pcp2spark(1) will listen for connections from an Apache Spark worker thread.

    spark_export_port: 44325

Specify the port for pcp2spark(1) to listen on.

## Dependencies

None.

## Example Playbooks

Make local Spark executor metrics available to PCP analysis tools.

```yaml
- hosts: monitoring
  roles:
    - role: performancecopilot.metrics.spark
```

Setup export of PCP metrics to a Spark worker thread.

```yaml
- hosts: monitoring
  roles:
    - role: performancecopilot.metrics.spark
      vars:
        spark_export_port: 44388
```

## License

MIT

## Author Information

An official role for PCP, maintained by the PCP developers <pcp@groups.io>

#' F1 Score
#'
#' \code{f1} computes the F1 Score in the context of information retrieval problems.
#' 
#' \code{f1} is defined as \eqn{2 * precision * recall / (precision + recall)}. In the
#' context of information retrieval problems, precision is the proportion of retrieved
#' documents that are relevant to a query and recall is the proportion of relevant
#' documents that are successfully retrieved by a query. If there are zero relevant
#' documents that are retrieved, zero relevant documents, or zero predicted documents,
#' \code{f1} is defined as \code{0}.
#' 
#' @export
#' @seealso \code{\link{apk}} \code{\link{mapk}}
#' @param actual The ground truth vector of relevant documents. The vector can contain
#'               any numeric or character values, order does not matter, and the
#'               vector does not need to be the same length as \code{predicted}.
#' @param predicted The predicted vector of retrieved documents. The vector can contain
#'                  any numeric or character values, order does not matter, and the
#'                  vector does not need to be the same length as \code{actual}.
#' @examples
#' actual <- c('a', 'c', 'd')
#' predicted <- c('d', 'e')
#' f1(actual, predicted)
f1 <- function (actual, predicted) {
    act <- unique(actual)
    pred <- unique(predicted)
    
    tp <- length(intersect(act, pred))
    fp <- length(setdiff(pred, act))
    fn <- length(setdiff(act, pred))
    
    if (tp == 0) {
        return(0)
    } else {
        precision <- tp / (tp + fp)
        recall <- tp / (tp + fn)
        return(2 * precision * recall / (precision + recall))
    }
}

#' Average Precision at k
#'
#' \code{apk} computes the average precision at k, in the context of information
#' retrieval problems.
#' 
#' \code{apk} loops over the first k values of \code{predicted}. For each value, if
#' the value is contained within \code{actual} and has not been predicted before,
#' we increment the number of sucesses by one and increment our score by the number
#' of successes divided by k. Then, we return our final score divided by the number
#' of relevant documents (i.e. the length of \code{actual}).
#' 
#' \code{apk} will return \code{NaN} if \code{length(actual)} equals \code{0}.
#'
#' @param k The number of elements of \code{predicted} to consider in the calculation.
#' @inheritParams f1
#' @param predicted The predicted vector of retrieved documents. The vector can
#'                  contain any numeric of character values. However, unlike \code{actual},
#'                  order does matter, with the most documents deemed most likely to
#'                  be relevant at the beginning.
#' @export
#' @seealso \code{\link{apk}} \code{\link{f1}}
#' @examples
#' actual <- c('a', 'b', 'd')
#' predicted <- c('b', 'c', 'a', 'e', 'f')
#' apk(3, actual, predicted)
apk <- function(k, actual, predicted) {
    score <- 0.0
    cnt <- 0.0
    for (i in 1:min(k,length(predicted))) {
        if (predicted[i] %in% actual && !(predicted[i] %in% predicted[0:(i-1)])) {
            cnt <- cnt + 1
            score <- score + cnt / i
        }
    }
    return(score / min(length(actual), k))
}

#' Mean Average Precision at k
#'
#' \code{mapk} computes the mean average precision at k for a set of predictions, in
#' the context of information retrieval problems.
#' 
#' \code{mapk} evaluates \code{apk} for each pair of elements from \code{actual} and
#' \code{predicted}.
#'
#' @inheritParams apk
#' @param actual A list of vectors, where each vector represents a ground truth vector
#'               of relevant documents. In each vector, the elements can be numeric
#'               or character values, and the order of the elements does not matter.
#' @param predicted A list of vectors, where each vector represents the predicted vector
#'                  of retrieved documents for the corresponding element of \code{actual}.
#'                  In each vector, the order of the elements does matter, with the
#'                  elements believed most likely to be relevant at the beginning.
#' @export
#' @seealso \code{\link{apk}} \code{\link{f1}}
#' @examples
#' actual <- list(c('a', 'b'), c('a'), c('x', 'y', 'b'))
#' predicted <- list(c('a', 'c', 'd'), c('x', 'b', 'a', 'b'), c('y'))
#' mapk(2, actual, predicted)
#' 
#' actual <- list(c(1, 5, 7, 9), c(2, 3), c(2, 5, 6))
#' predicted <- list(c(5, 6, 7, 8, 9), c(1, 2, 3), c(2, 4, 6, 8))
#' mapk(3, actual, predicted)
mapk <- function(k, actual, predicted) {
    if (length(actual) == 0 || length(predicted) == 0) {
        return(0.0)
    }
    
    convert_to_list <- function(x) {
        if (is.list(x)) {
            return(x)
        } else {
            arg_name <- deparse(substitute(x))
            warning(paste(arg_name, 'should be a list of vectors. Converting to a list.'))
            return(list(x))
        }
    }
    
    act <- convert_to_list(actual)
    pred <- convert_to_list(predicted)
    
    scores <- rep(0, length(act))
    for (i in 1:length(scores)) {
        scores[i] <- apk(k, act[[i]], pred[[i]])
    }
    return(mean(scores))
}

#' Mean Absolute Scaled Error
#' 
#' \code{mase} computes the mean absolute scaled error between two numeric
#' vectors. This function is only intended for time series data, where
#' \code{actual} and \code{numeric} are numeric vectors ordered by time.
#' 
#' @param actual The ground truth numeric vector ordered in time, with most recent
#'               observation at the end of the vector.
#' @param predicted The predicted numeric vector ordered in time, where each element
#'                  of the vector represents a prediction for the corresponding
#'                  element of \code{actual}.
#' @param step_size A positive integer that specifies how many observations to look back
#'                  in time in order to compute the naive forecast. The default is
#'                  \code{1}, which means that the naive forecast for the current time
#'                  period is the actual value of the previous period.
#'                  
#'                  However, if \code{actual} and \code{predictions} were quarterly
#'                  predictions over many years, letting \code{step_size = 4}, would
#'                  mean that the naive forecast for the current time period would
#'                  be the actual value from the same quarter last year. In this way,
#'                  \code{mase} can account for seasonality.
#' @export
#' @seealso \code{\link{smape}} \code{\link{mape}}
#' @examples 
#' actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
#' predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
#' step_size <- 1
#' mase(actual, predicted, step_size)
mase <- function(actual, predicted, step_size = 1) {
    
    naive_start <- step_size + 1
    n <- as.numeric(length(actual))
    naive_end <- n - step_size
    
    sum_errors <- sum(ae(actual, predicted))
    naive_errors <- sum(ae(actual[naive_start:n], actual[1:naive_end]))
    return(sum_errors / (n * naive_errors / naive_end))
}

#' @title Inherit Documentation for Binary Classification Metrics
#' @name params_binary
#' @description This object provides the documentation for the parameters of functions
#'              that provide binary classification metrics
#' @param actual The ground truth binary numeric vector containing 1 for the positive
#'               class and 0 for the negative class.
#' @param predicted The predicted binary numeric vector containing 1 for the positive
#'                  class and 0 for the negative class. Each element represents the
#'                  prediction for the corresponding element in \code{actual}.
NULL

#' Area under the ROC curve (AUC)
#'
#' \code{auc} computes the area under the receiver-operator characteristic curve (AUC).
#' 
#' \code{auc} uses the fact that the area under the ROC curve is equal to the probability
#' that a randomly chosen positive observation has a higher predicted value than a
#' randomly chosen negative value. In order to compute this probability, we can
#' calculate the Mann-Whitney U statistic. This method is very fast, since we
#' do not need to compute the ROC curve first.
#'
#' @inheritParams params_binary
#' @param predicted A numeric vector of predicted values, where the smallest values correspond
#'                  to the observations most believed to be in the negative class
#'                  and the largest values indicate the observations most believed
#'                  to be in the positive class. Each element represents the
#'                  prediction for the corresponding element in \code{actual}.
#' @export
#' @examples
#' actual <- c(1, 1, 1, 0, 0, 0)
#' predicted <- c(0.9, 0.8, 0.4, 0.5, 0.3, 0.2)
#' auc(actual, predicted)
auc <- function(actual, predicted) {
    if (length(actual) != length(predicted)) {
        msg <- "longer object length is not a multiple of shorter object length"
        warning(msg)
    }
    r <- rank(predicted)
    n_pos <- as.numeric(sum(actual == 1))
    n_neg <- length(actual) - n_pos
    return((sum(r[actual == 1]) - n_pos * (n_pos + 1) / 2) / (n_pos * n_neg))
}

#' Log Loss
#'
#' \code{ll} computes the elementwise log loss between two numeric vectors.
#'
#' @inheritParams params_binary
#' @param predicted A numeric vector of predicted values, where the values correspond
#'                  to the probabilities that each observation in \code{actual}
#'                  belongs to the positive class
#' @export
#' @seealso \code{\link{logLoss}}
#' @examples
#' actual <- c(1, 1, 1, 0, 0, 0)
#' predicted <- c(0.9, 0.8, 0.4, 0.5, 0.3, 0.2)
#' ll(actual, predicted)
ll <- function(actual, predicted) {
    score <- -(actual * log(predicted) + (1 - actual) * log(1 - predicted))
    score[actual == predicted] <- 0
    score[is.nan(score)] <- Inf
    return(score)
}

#' Mean Log Loss
#'
#' \code{logLoss} computes the average log loss between two numeric vectors.
#'
#' @inheritParams ll
#' @export
#' @seealso \code{\link{ll}}
#' @examples
#' actual <- c(1, 1, 1, 0, 0, 0)
#' predicted <- c(0.9, 0.8, 0.4, 0.5, 0.3, 0.2)
#' logLoss(actual, predicted)
logLoss <- function(actual, predicted) {
    return(mean(ll(actual, predicted)))
}



#' Precision
#' 
#' \code{precision} computes proportion of observations predicted to be in the
#'                  positive class (i.e. the element in \code{predicted} equals 1)
#'                  that actually belong to the positive class (i.e. the element 
#'                  in \code{actual} equals 1)
#'     
#' @inheritParams params_binary
#' @export
#' @seealso \code{\link{recall}} \code{\link{fbeta_score}}
#' @examples 
#' actual <- c(1, 1, 1, 0, 0, 0)
#' predicted <- c(1, 1, 1, 1, 1, 1)
#' precision(actual, predicted)
precision <- function(actual, predicted) {
    return(mean(actual[predicted == 1]))
}

#' Recall
#' 
#' \code{recall} computes proportion of observations in the positive class
#'               (i.e. the element in \code{actual} equals 1) that are predicted
#'               to be in the positive class (i.e. the element in \code{predicted}
#'               equals 1)
#'     
#' @inheritParams params_binary
#' @export
#' @seealso \code{\link{precision}} \code{\link{fbeta_score}}
#' @examples 
#' actual <- c(1, 1, 1, 0, 0, 0)
#' predicted <- c(1, 0, 1, 1, 1, 1)
#' recall(actual, predicted)
recall <- function(actual, predicted) {
    return(mean(predicted[actual == 1]))
}

#' F-beta Score
#' 
#' \code{fbeta_score} computes a weighted harmonic mean of Precision and Recall.
#'                    The \code{beta} parameter controls the weighting.
#'                    
#' @inheritParams params_binary
#' @param beta A non-negative real number controlling how close the F-beta score is to 
#'             either Precision or Recall. When \code{beta} is at the default of 1, 
#'             the F-beta Score is exactly an equally weighted harmonic mean.
#'             The F-beta score will weight toward Precision when \code{beta} is less 
#'             than one.  The F-beta score will weight toward Recall when \code{beta} is
#'             greater than one.
#' @export
#' @seealso \code{\link{precision}} \code{\link{recall}}
#' @examples 
#' actual <- c(1, 1, 1, 0, 0, 0)
#' predicted <- c(1, 0, 1, 1, 1, 1)
#' recall(actual, predicted)
fbeta_score <- function(actual, predicted, beta = 1) {
    prec <- precision(actual, predicted)
    rec <- recall(actual, predicted)
    return((1 + beta^2) * prec * rec / ((beta^2 * prec) + rec))
}

#' @title Inherit Documentation for Classification Metrics
#' @name params_classification
#' @description This object provides the documentation for the parameters of functions
#'              that provide classification metrics
#' @param actual The ground truth vector, where elements of the vector can be any variable type.
#' @param predicted The predicted vector, where elements of the vector represent a
#'                  prediction for the corresponding value in \code{actual}.
NULL

#' Classification Error
#'
#' \code{ce} is defined as the proportion of elements in \code{actual} that are not equal
#' to the corresponding element in \code{predicted}.
#'
#' @inheritParams params_classification
#' @export
#' @seealso \code{\link{accuracy}}
#' @examples
#' actual <- c('a', 'a', 'c', 'b', 'c')
#' predicted <- c('a', 'b', 'c', 'b', 'a')
#' ce(actual, predicted)
ce <- function(actual, predicted) {
    return(mean(actual != predicted))
}

#' Accuracy
#' 
#' \code{accuracy} is defined as the proportion of elements in \code{actual} that are
#' equal to the corresponding element in \code{predicted}
#' 
#' @inheritParams params_classification
#' @export
#' @seealso \code{\link{ce}}
#' @examples
#' actual <- c('a', 'a', 'c', 'b', 'c')
#' predicted <- c('a', 'b', 'c', 'b', 'a')
#' accuracy(actual, predicted)
accuracy <- function(actual, predicted) {
    return(1 - ce(actual, predicted))
}

#' Quadratic Weighted Kappa
#'
#' \code{ScoreQuadraticWeightedKappa} computes the quadratic weighted kappa between
#' two vectors of integers
#'
#' @param rater.a An integer vector of the first rater's ratings.
#' @param rater.b An integer vector of the second rater's ratings.
#' @param min.rating The minimum possible rating.
#' @param max.rating The maximum possible rating.
#' @export
#' @seealso \code{\link{MeanQuadraticWeightedKappa}}
#' @examples
#' rater.a <- c(1, 4, 5, 5, 2, 1)
#' rater.b <- c(2, 2, 4, 5, 3, 3)
#' ScoreQuadraticWeightedKappa(rater.a, rater.b, 1, 5)
ScoreQuadraticWeightedKappa <- function(rater.a
                                        , rater.b
                                        , min.rating = min(c(rater.a, rater.b))
                                        , max.rating = max(c(rater.a, rater.b))
) {
    
    rater.a <- factor(rater.a, levels = min.rating:max.rating)
    rater.b <- factor(rater.b, levels = min.rating:max.rating)
    
    #pairwise frequencies
    confusion.mat <- table(data.frame(rater.a, rater.b))
    confusion.mat <- confusion.mat / sum(confusion.mat)
    
    #get expected pairwise frequencies under independence
    histogram.a <- table(rater.a) / length(table(rater.a))
    histogram.b <- table(rater.b) / length(table(rater.b))
    expected.mat <- histogram.a %*% t(histogram.b)
    expected.mat <- expected.mat / sum(expected.mat)
    
    #get weights
    labels <- as.numeric( as.vector (names(table(rater.a))))
    weights <- outer(labels, labels, FUN = function(x, y) (x - y) ^ 2)
    
    #calculate kappa
    return(1 - sum(weights * confusion.mat) / sum(weights * expected.mat))
}

#' Mean Quadratic Weighted Kappa
#'
#' \code{MeanQuadraticWeightedKappa} computes the mean quadratic weighted kappa,
#' which can optionally be weighted
#'
#' @param kappas A numeric vector of possible kappas.
#' @param weights An optional numeric vector of ratings.
#' @export
#' @seealso \code{\link{ScoreQuadraticWeightedKappa}}
#' @examples
#' kappas <- c(0.3 ,0.2, 0.2, 0.5, 0.1, 0.2)
#' weights <- c(1.0, 2.5, 1.0, 1.0, 2.0, 3.0)
#' MeanQuadraticWeightedKappa(kappas, weights)
MeanQuadraticWeightedKappa <- function(kappas
                                       , weights = rep(1, length(kappas))
) {
    
    weights <- weights / mean(weights)
    
    max999 <- function(x) sign(x)*min(0.999,abs(x))
    min001 <- function(x) sign(x)*max(0.001,abs(x))
    kappas <- sapply(kappas, max999)
    kappas <- sapply(kappas, min001)
    
    r2z <- function(x) 0.5*log((1+x)/(1-x))
    z2r <- function(x) (exp(2*x)-1) / (exp(2*x)+1)
    kappas <- sapply(kappas, r2z)
    kappas <- kappas * weights
    kappas <- mean(kappas)
    return(z2r(kappas))
}

#' @title Inherit Documentation for Regression Metrics
#' @name params_regression
#' @description This object provides the documentation for the parameters of functions
#'              that provide regression metrics
#' @param actual The ground truth numeric vector.
#' @param predicted The predicted numeric vector, where each element in the vector
#'                  is a prediction for the corresponding element in \code{actual}.
NULL

#' Bias
#' 
#' \code{bias} computes the average amount by which \code{actual} is greater than
#' \code{predicted}.
#' 
#' If a model is unbiased \code{bias(actual, predicted)} should be close to zero.
#' Bias is calculated by taking the average of (\code{actual} - \code{predicted}).
#' 
#' @inheritParams params_regression
#' @export
#' @seealso \code{\link{percent_bias}}
#' @examples 
#' actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
#' predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
#' bias(actual, predicted)
bias <- function(actual, predicted) {
    return(mean(actual - predicted))
}

#' Percent Bias
#' 
#' \code{percent_bias} computes the average amount that \code{actual} is greater
#' than \code{predicted} as a percentage of the absolute value of \code{actual}.
#' 
#' If a model is unbiased \code{percent_bias(actual, predicted)} should be close
#' to zero. Percent Bias is calculated by taking the average of
#' (\code{actual} - \code{predicted}) / \code{abs(actual)} across all observations.
#' 
#' \code{percent_bias} will give \code{-Inf}, \code{Inf}, or \code{NaN}, if any
#' elements of \code{actual} are \code{0}.
#' 
#' @inheritParams params_regression
#' @export
#' @seealso \code{\link{bias}}
#' @examples 
#' actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
#' predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
#' percent_bias(actual, predicted)
percent_bias <- function(actual, predicted) {
    return(mean((actual - predicted) / abs(actual)))
}

#' Squared Error
#'
#' \code{se} computes the elementwise squared difference between two numeric vectors.
#'
#' @inheritParams params_regression
#' @export
#' @seealso \code{\link{mse}} \code{\link{rmse}}
#' @examples
#' actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
#' predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
#' se(actual, predicted)
se <- function(actual, predicted) {
    return((actual - predicted) ^ 2)
}

#' Sum of Squared Errors
#' 
#' \code{sse} computes the sum of the squared differences between two numeric vectors.
#' 
#' @inheritParams params_regression
#' @export
#' @seealso \code{\link{mse}}
#' @examples
#' actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
#' predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
#' sse(actual, predicted)
sse <- function(actual, predicted) {
    return(sum(se(actual, predicted)))
}

#' Mean Squared Error
#'
#' \code{mse} computes the average squared difference between two numeric vectors.
#'
#' @inheritParams params_regression
#' @export
#' @seealso \code{\link{rmse}} \code{\link{mae}}
#' @examples
#' actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
#' predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
#' mse(actual, predicted)
mse <- function(actual, predicted) {
    return(mean(se(actual, predicted)))
}

#' Root Mean Squared Error
#'
#' \code{rmse} computes the root mean squared error between two numeric vectors
#'
#' @inheritParams params_regression
#' @export
#' @seealso \code{\link{mse}}
#' @examples
#' actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
#' predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
#' rmse(actual, predicted)
rmse <- function(actual, predicted) {
    return(sqrt(mse(actual, predicted)))
}

#' Absolute Error
#'
#' \code{ae} computes the elementwise absolute difference between two numeric vectors.
#'
#' @inheritParams params_regression
#' @export
#' @seealso \code{\link{mae}} \code{\link{mdae}} \code{\link{mape}}
#' @examples
#' actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
#' predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
#' ae(actual, predicted)
ae <- function(actual, predicted) {
    return(abs(actual - predicted))
}

#' Mean Absolute Error
#'
#' \code{mae} computes the average absolute difference between two numeric vectors.
#'
#' @inheritParams params_regression
#' @export
#' @seealso \code{\link{mdae}} \code{\link{mape}}
#' @examples
#' actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
#' predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
#' mae(actual, predicted)
mae <- function(actual, predicted) {
    return(mean(ae(actual, predicted)))
}

#' Median Absolute Error
#'
#' \code{mdae} computes the median absolute difference between two numeric vectors.
#'
#' @importFrom stats median
#' @inheritParams params_regression
#' @export
#' @seealso \code{\link{mae}} \code{\link{mape}}
#' @examples
#' actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
#' predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
#' mdae(actual, predicted)
mdae <- function(actual, predicted) {
    return(stats::median(ae(actual, predicted)))
}

#' Absolute Percent Error
#' 
#' \code{ape} computes the elementwise absolute percent difference between two numeric
#' vectors
#' 
#' \code{ape} is calculated as (\code{actual} - \code{predicted}) / \code{abs(actual)}.
#' This means that the function will return \code{-Inf}, \code{Inf}, or \code{NaN}
#' if \code{actual} is zero.
#' 
#' @inheritParams params_regression
#' @export
#' @seealso \code{\link{mape}} \code{smape}
#' @examples 
#' actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
#' predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
#' ape(actual, predicted)
ape <- function(actual, predicted) {
    return(ae(actual, predicted) / abs(actual))
}

#' Mean Absolute Percent Error
#' 
#' \code{mape} computes the average absolute percent difference between two numeric vectors.
#' 
#' \code{mape} is calculated as the average of (\code{actual} - \code{predicted}) / \code{abs(actual)}.
#' This means that the function will return \code{-Inf}, \code{Inf}, or \code{NaN}
#' if \code{actual} is zero. Due to the instability at or near zero, \code{smape} or
#' \code{mase} are often used as alternatives.
#' 
#' @inheritParams params_regression
#' @export
#' @seealso \code{\link{mae}} \code{\link{smape}} \code{\link{mase}}
#' @examples 
#' actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
#' predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
#' mape(actual, predicted)
mape <- function(actual, predicted) {
    return(mean(ape(actual, predicted)))
}

#' Symmetric Mean Absolute Percentage Error
#' 
#' \code{smape} computes the symmetric mean absolute percentage error between
#' two numeric vectors.
#' 
#' \code{smape} is defined as two times the average of \code{abs(actual - predicted) / (abs(actual) + abs(predicted))}.
#' Therefore, at the elementwise level, it will provide \code{NaN} only if \code{actual} and \code{predicted}
#' are both zero. It has an upper bound of \code{2}, when either \code{actual} or
#' \code{predicted} are zero or when \code{actual} and \code{predicted} are opposite
#' signs.
#' 
#' \code{smape} is symmetric in the sense that \code{smape(x, y) = smape(y, x)}.
#' 
#' @inheritParams params_regression
#' @export
#' @seealso \code{\link{mape}} \code{\link{mase}}
#' @examples 
#' actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
#' predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
#' smape(actual, predicted)
smape <- function(actual, predicted) {
    return(2 * mean(ae(actual, predicted) / (abs(actual) + abs(predicted))))
}

#' Squared Log Error
#'
#' \code{sle} computes the elementwise squares of the differences in the logs of two numeric vectors.
#' 
#' \code{sle} adds one to both \code{actual} and \code{predicted} before taking
#' the natural logarithm of each to avoid taking the natural log of zero. As a result,
#' the function can be used if \code{actual} or \code{predicted} have zero-valued
#' elements. But this function is not appropriate if either are negative valued.
#'
#' @param actual The ground truth non-negative vector
#' @param predicted The predicted non-negative vector, where each element in the vector
#'                  is a prediction for the corresponding element in \code{actual}.
#' @export
#' @seealso \code{\link{msle}} \code{\link{rmsle}}
#' @examples
#' actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
#' predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
#' sle(actual, predicted)
sle <- function(actual, predicted) {
    return((log(1 + actual) - log(1 + predicted)) ^ 2)
}

#' Mean Squared Log Error
#'
#' \code{msle} computes the average of squared log error between two numeric vectors.
#' 
#' \code{msle} adds one to both \code{actual} and \code{predicted} before taking
#' the natural logarithm to avoid taking the natural log of zero. As a result,
#' the function can be used if \code{actual} or \code{predicted} have zero-valued
#' elements. But this function is not appropriate if either are negative valued.
#'
#' @inheritParams sle
#' @export
#' @seealso \code{\link{rmsle}} \code{\link{sle}}
#' @examples
#' actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
#' predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
#' msle(actual, predicted)
msle <- function(actual, predicted) {
    mean(sle(actual, predicted))
}

#' Root Mean Squared Log Error
#'
#' \code{rmsle} computes the root mean squared log error between two numeric vectors.
#' 
#' \code{rmsle} adds one to both \code{actual} and \code{predicted} before taking
#' the natural logarithm to avoid taking the natural log of zero. As a result,
#' the function can be used if \code{actual} or \code{predicted} have zero-valued
#' elements. But this function is not appropriate if either are negative valued.
#'
#' @inheritParams sle
#' @export
#' @seealso \code{\link{msle}} \code{\link{sle}}
#' @examples
#' actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
#' predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
#' rmsle(actual, predicted)
rmsle <- function(actual, predicted) {
    sqrt(msle(actual, predicted))
}

#' Relative Squared Error
#'
#' \code{rse} computes the relative squared error between two numeric vectors.
#' 
#' \code{rse} divides \code{sse(actual, predicted)} by \code{sse(actual, mean(actual))},
#' meaning that it provides the squared error of the predictions relative to a naive model that
#' predicted the mean for every data point.
#' 
#' @inheritParams params_regression
#' @export
#' @seealso \code{\link{rrse}} \code{\link{rae}}
#' @examples
#' actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
#' predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
#' rse(actual, predicted)
rse <- function (actual, predicted) {
    return(sse(actual, predicted) / sse(actual, mean(actual)))
}

#' Root Relative Squared Error
#'
#' \code{rrse} computes the root relative squared error between two numeric vectors.
#' 
#' \code{rrse} takes the square root of \code{sse(actual, predicted)} divided by
#' \code{sse(actual, mean(actual))}, meaning that it provides the squared error of the
#' predictions relative to a naive model that predicted the mean for every data point.
#'
#' @inheritParams params_regression
#' @export
#' @seealso \code{\link{rse}} \code{\link{rae}}
#' @examples
#' actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
#' predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
#' rrse(actual, predicted)
rrse <- function(actual, predicted) {
    return(sqrt(rse(actual, predicted)))
}

#' Relative Absolute Error
#'
#' \code{rae} computes the relative absolute error between two numeric vectors.
#' 
#' \code{rae} divides \code{sum(ae(actual, predicted))} by \code{sum(ae(actual, mean(actual)))},
#' meaning that it provides the absolute error of the predictions relative to a naive model that
#' predicted the mean for every data point.
#'
#' @inheritParams params_regression
#' @export
#' @seealso \code{\link{rse}} \code{\link{rrse}}
#' @examples
#' actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
#' predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
#' rrse(actual, predicted)
rae <- function(actual, predicted) {
    return(sum(ae(predicted, actual)) / sum(ae(actual, mean(actual))))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classification.R
\name{ScoreQuadraticWeightedKappa}
\alias{ScoreQuadraticWeightedKappa}
\title{Quadratic Weighted Kappa}
\usage{
ScoreQuadraticWeightedKappa(rater.a, rater.b, min.rating = min(c(rater.a,
  rater.b)), max.rating = max(c(rater.a, rater.b)))
}
\arguments{
\item{rater.a}{An integer vector of the first rater's ratings.}

\item{rater.b}{An integer vector of the second rater's ratings.}

\item{min.rating}{The minimum possible rating.}

\item{max.rating}{The maximum possible rating.}
}
\description{
\code{ScoreQuadraticWeightedKappa} computes the quadratic weighted kappa between
two vectors of integers
}
\examples{
rater.a <- c(1, 4, 5, 5, 2, 1)
rater.b <- c(2, 2, 4, 5, 3, 3)
ScoreQuadraticWeightedKappa(rater.a, rater.b, 1, 5)
}
\seealso{
\code{\link{MeanQuadraticWeightedKappa}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classification.R
\name{params_classification}
\alias{params_classification}
\title{Inherit Documentation for Classification Metrics}
\arguments{
\item{actual}{The ground truth vector, where elements of the vector can be any variable type.}

\item{predicted}{The predicted vector, where elements of the vector represent a
prediction for the corresponding value in \code{actual}.}
}
\description{
This object provides the documentation for the parameters of functions
             that provide classification metrics
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/binary_classification.R
\name{fbeta_score}
\alias{fbeta_score}
\title{F-beta Score}
\usage{
fbeta_score(actual, predicted, beta = 1)
}
\arguments{
\item{actual}{The ground truth binary numeric vector containing 1 for the positive
class and 0 for the negative class.}

\item{predicted}{The predicted binary numeric vector containing 1 for the positive
class and 0 for the negative class. Each element represents the
prediction for the corresponding element in \code{actual}.}

\item{beta}{A non-negative real number controlling how close the F-beta score is to 
either Precision or Recall. When \code{beta} is at the default of 1, 
the F-beta Score is exactly an equally weighted harmonic mean.
The F-beta score will weight toward Precision when \code{beta} is less 
than one.  The F-beta score will weight toward Recall when \code{beta} is
greater than one.}
}
\description{
\code{fbeta_score} computes a weighted harmonic mean of Precision and Recall.
                   The \code{beta} parameter controls the weighting.
}
\examples{
actual <- c(1, 1, 1, 0, 0, 0)
predicted <- c(1, 0, 1, 1, 1, 1)
recall(actual, predicted)
}
\seealso{
\code{\link{precision}} \code{\link{recall}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/binary_classification.R
\name{auc}
\alias{auc}
\title{Area under the ROC curve (AUC)}
\usage{
auc(actual, predicted)
}
\arguments{
\item{actual}{The ground truth binary numeric vector containing 1 for the positive
class and 0 for the negative class.}

\item{predicted}{A numeric vector of predicted values, where the smallest values correspond
to the observations most believed to be in the negative class
and the largest values indicate the observations most believed
to be in the positive class. Each element represents the
prediction for the corresponding element in \code{actual}.}
}
\description{
\code{auc} computes the area under the receiver-operator characteristic curve (AUC).
}
\details{
\code{auc} uses the fact that the area under the ROC curve is equal to the probability
that a randomly chosen positive observation has a higher predicted value than a
randomly chosen negative value. In order to compute this probability, we can
calculate the Mann-Whitney U statistic. This method is very fast, since we
do not need to compute the ROC curve first.
}
\examples{
actual <- c(1, 1, 1, 0, 0, 0)
predicted <- c(0.9, 0.8, 0.4, 0.5, 0.3, 0.2)
auc(actual, predicted)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/binary_classification.R
\name{recall}
\alias{recall}
\title{Recall}
\usage{
recall(actual, predicted)
}
\arguments{
\item{actual}{The ground truth binary numeric vector containing 1 for the positive
class and 0 for the negative class.}

\item{predicted}{The predicted binary numeric vector containing 1 for the positive
class and 0 for the negative class. Each element represents the
prediction for the corresponding element in \code{actual}.}
}
\description{
\code{recall} computes proportion of observations in the positive class
              (i.e. the element in \code{actual} equals 1) that are predicted
              to be in the positive class (i.e. the element in \code{predicted}
              equals 1)
}
\examples{
actual <- c(1, 1, 1, 0, 0, 0)
predicted <- c(1, 0, 1, 1, 1, 1)
recall(actual, predicted)
}
\seealso{
\code{\link{precision}} \code{\link{fbeta_score}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regression.R
\name{smape}
\alias{smape}
\title{Symmetric Mean Absolute Percentage Error}
\usage{
smape(actual, predicted)
}
\arguments{
\item{actual}{The ground truth numeric vector.}

\item{predicted}{The predicted numeric vector, where each element in the vector
is a prediction for the corresponding element in \code{actual}.}
}
\description{
\code{smape} computes the symmetric mean absolute percentage error between
two numeric vectors.
}
\details{
\code{smape} is defined as two times the average of \code{abs(actual - predicted) / (abs(actual) + abs(predicted))}.
Therefore, at the elementwise level, it will provide \code{NaN} only if \code{actual} and \code{predicted}
are both zero. It has an upper bound of \code{2}, when either \code{actual} or
\code{predicted} are zero or when \code{actual} and \code{predicted} are opposite
signs.

\code{smape} is symmetric in the sense that \code{smape(x, y) = smape(y, x)}.
}
\examples{
actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
smape(actual, predicted)
}
\seealso{
\code{\link{mape}} \code{\link{mase}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regression.R
\name{params_regression}
\alias{params_regression}
\title{Inherit Documentation for Regression Metrics}
\arguments{
\item{actual}{The ground truth numeric vector.}

\item{predicted}{The predicted numeric vector, where each element in the vector
is a prediction for the corresponding element in \code{actual}.}
}
\description{
This object provides the documentation for the parameters of functions
             that provide regression metrics
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regression.R
\name{sle}
\alias{sle}
\title{Squared Log Error}
\usage{
sle(actual, predicted)
}
\arguments{
\item{actual}{The ground truth non-negative vector}

\item{predicted}{The predicted non-negative vector, where each element in the vector
is a prediction for the corresponding element in \code{actual}.}
}
\description{
\code{sle} computes the elementwise squares of the differences in the logs of two numeric vectors.
}
\details{
\code{sle} adds one to both \code{actual} and \code{predicted} before taking
the natural logarithm of each to avoid taking the natural log of zero. As a result,
the function can be used if \code{actual} or \code{predicted} have zero-valued
elements. But this function is not appropriate if either are negative valued.
}
\examples{
actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
sle(actual, predicted)
}
\seealso{
\code{\link{msle}} \code{\link{rmsle}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regression.R
\name{bias}
\alias{bias}
\title{Bias}
\usage{
bias(actual, predicted)
}
\arguments{
\item{actual}{The ground truth numeric vector.}

\item{predicted}{The predicted numeric vector, where each element in the vector
is a prediction for the corresponding element in \code{actual}.}
}
\description{
\code{bias} computes the average amount by which \code{actual} is greater than
\code{predicted}.
}
\details{
If a model is unbiased \code{bias(actual, predicted)} should be close to zero.
Bias is calculated by taking the average of (\code{actual} - \code{predicted}).
}
\examples{
actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
bias(actual, predicted)
}
\seealso{
\code{\link{percent_bias}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classification.R
\name{ce}
\alias{ce}
\title{Classification Error}
\usage{
ce(actual, predicted)
}
\arguments{
\item{actual}{The ground truth vector, where elements of the vector can be any variable type.}

\item{predicted}{The predicted vector, where elements of the vector represent a
prediction for the corresponding value in \code{actual}.}
}
\description{
\code{ce} is defined as the proportion of elements in \code{actual} that are not equal
to the corresponding element in \code{predicted}.
}
\examples{
actual <- c('a', 'a', 'c', 'b', 'c')
predicted <- c('a', 'b', 'c', 'b', 'a')
ce(actual, predicted)
}
\seealso{
\code{\link{accuracy}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/time_series.R
\name{mase}
\alias{mase}
\title{Mean Absolute Scaled Error}
\usage{
mase(actual, predicted, step_size = 1)
}
\arguments{
\item{actual}{The ground truth numeric vector ordered in time, with most recent
observation at the end of the vector.}

\item{predicted}{The predicted numeric vector ordered in time, where each element
of the vector represents a prediction for the corresponding
element of \code{actual}.}

\item{step_size}{A positive integer that specifies how many observations to look back
in time in order to compute the naive forecast. The default is
\code{1}, which means that the naive forecast for the current time
period is the actual value of the previous period.

However, if \code{actual} and \code{predictions} were quarterly
predictions over many years, letting \code{step_size = 4}, would
mean that the naive forecast for the current time period would
be the actual value from the same quarter last year. In this way,
\code{mase} can account for seasonality.}
}
\description{
\code{mase} computes the mean absolute scaled error between two numeric
vectors. This function is only intended for time series data, where
\code{actual} and \code{numeric} are numeric vectors ordered by time.
}
\examples{
actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
step_size <- 1
mase(actual, predicted, step_size)
}
\seealso{
\code{\link{smape}} \code{\link{mape}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/information_retrieval.R
\name{f1}
\alias{f1}
\title{F1 Score}
\usage{
f1(actual, predicted)
}
\arguments{
\item{actual}{The ground truth vector of relevant documents. The vector can contain
any numeric or character values, order does not matter, and the
vector does not need to be the same length as \code{predicted}.}

\item{predicted}{The predicted vector of retrieved documents. The vector can contain
any numeric or character values, order does not matter, and the
vector does not need to be the same length as \code{actual}.}
}
\description{
\code{f1} computes the F1 Score in the context of information retrieval problems.
}
\details{
\code{f1} is defined as \eqn{2 * precision * recall / (precision + recall)}. In the
context of information retrieval problems, precision is the proportion of retrieved
documents that are relevant to a query and recall is the proportion of relevant
documents that are successfully retrieved by a query. If there are zero relevant
documents that are retrieved, zero relevant documents, or zero predicted documents,
\code{f1} is defined as \code{0}.
}
\examples{
actual <- c('a', 'c', 'd')
predicted <- c('d', 'e')
f1(actual, predicted)
}
\seealso{
\code{\link{apk}} \code{\link{mapk}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/binary_classification.R
\name{params_binary}
\alias{params_binary}
\title{Inherit Documentation for Binary Classification Metrics}
\arguments{
\item{actual}{The ground truth binary numeric vector containing 1 for the positive
class and 0 for the negative class.}

\item{predicted}{The predicted binary numeric vector containing 1 for the positive
class and 0 for the negative class. Each element represents the
prediction for the corresponding element in \code{actual}.}
}
\description{
This object provides the documentation for the parameters of functions
             that provide binary classification metrics
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regression.R
\name{ae}
\alias{ae}
\title{Absolute Error}
\usage{
ae(actual, predicted)
}
\arguments{
\item{actual}{The ground truth numeric vector.}

\item{predicted}{The predicted numeric vector, where each element in the vector
is a prediction for the corresponding element in \code{actual}.}
}
\description{
\code{ae} computes the elementwise absolute difference between two numeric vectors.
}
\examples{
actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
ae(actual, predicted)
}
\seealso{
\code{\link{mae}} \code{\link{mdae}} \code{\link{mape}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/information_retrieval.R
\name{apk}
\alias{apk}
\title{Average Precision at k}
\usage{
apk(k, actual, predicted)
}
\arguments{
\item{k}{The number of elements of \code{predicted} to consider in the calculation.}

\item{actual}{The ground truth vector of relevant documents. The vector can contain
any numeric or character values, order does not matter, and the
vector does not need to be the same length as \code{predicted}.}

\item{predicted}{The predicted vector of retrieved documents. The vector can
contain any numeric of character values. However, unlike \code{actual},
order does matter, with the most documents deemed most likely to
be relevant at the beginning.}
}
\description{
\code{apk} computes the average precision at k, in the context of information
retrieval problems.
}
\details{
\code{apk} loops over the first k values of \code{predicted}. For each value, if
the value is contained within \code{actual} and has not been predicted before,
we increment the number of sucesses by one and increment our score by the number
of successes divided by k. Then, we return our final score divided by the number
of relevant documents (i.e. the length of \code{actual}).

\code{apk} will return \code{NaN} if \code{length(actual)} equals \code{0}.
}
\examples{
actual <- c('a', 'b', 'd')
predicted <- c('b', 'c', 'a', 'e', 'f')
apk(3, actual, predicted)
}
\seealso{
\code{\link{apk}} \code{\link{f1}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regression.R
\name{msle}
\alias{msle}
\title{Mean Squared Log Error}
\usage{
msle(actual, predicted)
}
\arguments{
\item{actual}{The ground truth non-negative vector}

\item{predicted}{The predicted non-negative vector, where each element in the vector
is a prediction for the corresponding element in \code{actual}.}
}
\description{
\code{msle} computes the average of squared log error between two numeric vectors.
}
\details{
\code{msle} adds one to both \code{actual} and \code{predicted} before taking
the natural logarithm to avoid taking the natural log of zero. As a result,
the function can be used if \code{actual} or \code{predicted} have zero-valued
elements. But this function is not appropriate if either are negative valued.
}
\examples{
actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
msle(actual, predicted)
}
\seealso{
\code{\link{rmsle}} \code{\link{sle}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/binary_classification.R
\name{precision}
\alias{precision}
\title{Precision}
\usage{
precision(actual, predicted)
}
\arguments{
\item{actual}{The ground truth binary numeric vector containing 1 for the positive
class and 0 for the negative class.}

\item{predicted}{The predicted binary numeric vector containing 1 for the positive
class and 0 for the negative class. Each element represents the
prediction for the corresponding element in \code{actual}.}
}
\description{
\code{precision} computes proportion of observations predicted to be in the
                 positive class (i.e. the element in \code{predicted} equals 1)
                 that actually belong to the positive class (i.e. the element 
                 in \code{actual} equals 1)
}
\examples{
actual <- c(1, 1, 1, 0, 0, 0)
predicted <- c(1, 1, 1, 1, 1, 1)
precision(actual, predicted)
}
\seealso{
\code{\link{recall}} \code{\link{fbeta_score}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regression.R
\name{mape}
\alias{mape}
\title{Mean Absolute Percent Error}
\usage{
mape(actual, predicted)
}
\arguments{
\item{actual}{The ground truth numeric vector.}

\item{predicted}{The predicted numeric vector, where each element in the vector
is a prediction for the corresponding element in \code{actual}.}
}
\description{
\code{mape} computes the average absolute percent difference between two numeric vectors.
}
\details{
\code{mape} is calculated as the average of (\code{actual} - \code{predicted}) / \code{abs(actual)}.
This means that the function will return \code{-Inf}, \code{Inf}, or \code{NaN}
if \code{actual} is zero. Due to the instability at or near zero, \code{smape} or
\code{mase} are often used as alternatives.
}
\examples{
actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
mape(actual, predicted)
}
\seealso{
\code{\link{mae}} \code{\link{smape}} \code{\link{mase}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classification.R
\name{accuracy}
\alias{accuracy}
\title{Accuracy}
\usage{
accuracy(actual, predicted)
}
\arguments{
\item{actual}{The ground truth vector, where elements of the vector can be any variable type.}

\item{predicted}{The predicted vector, where elements of the vector represent a
prediction for the corresponding value in \code{actual}.}
}
\description{
\code{accuracy} is defined as the proportion of elements in \code{actual} that are
equal to the corresponding element in \code{predicted}
}
\examples{
actual <- c('a', 'a', 'c', 'b', 'c')
predicted <- c('a', 'b', 'c', 'b', 'a')
accuracy(actual, predicted)
}
\seealso{
\code{\link{ce}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/information_retrieval.R
\name{mapk}
\alias{mapk}
\title{Mean Average Precision at k}
\usage{
mapk(k, actual, predicted)
}
\arguments{
\item{k}{The number of elements of \code{predicted} to consider in the calculation.}

\item{actual}{A list of vectors, where each vector represents a ground truth vector
of relevant documents. In each vector, the elements can be numeric
or character values, and the order of the elements does not matter.}

\item{predicted}{A list of vectors, where each vector represents the predicted vector
of retrieved documents for the corresponding element of \code{actual}.
In each vector, the order of the elements does matter, with the
elements believed most likely to be relevant at the beginning.}
}
\description{
\code{mapk} computes the mean average precision at k for a set of predictions, in
the context of information retrieval problems.
}
\details{
\code{mapk} evaluates \code{apk} for each pair of elements from \code{actual} and
\code{predicted}.
}
\examples{
actual <- list(c('a', 'b'), c('a'), c('x', 'y', 'b'))
predicted <- list(c('a', 'c', 'd'), c('x', 'b', 'a', 'b'), c('y'))
mapk(2, actual, predicted)

actual <- list(c(1, 5, 7, 9), c(2, 3), c(2, 5, 6))
predicted <- list(c(5, 6, 7, 8, 9), c(1, 2, 3), c(2, 4, 6, 8))
mapk(3, actual, predicted)
}
\seealso{
\code{\link{apk}} \code{\link{f1}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classification.R
\name{MeanQuadraticWeightedKappa}
\alias{MeanQuadraticWeightedKappa}
\title{Mean Quadratic Weighted Kappa}
\usage{
MeanQuadraticWeightedKappa(kappas, weights = rep(1, length(kappas)))
}
\arguments{
\item{kappas}{A numeric vector of possible kappas.}

\item{weights}{An optional numeric vector of ratings.}
}
\description{
\code{MeanQuadraticWeightedKappa} computes the mean quadratic weighted kappa,
which can optionally be weighted
}
\examples{
kappas <- c(0.3 ,0.2, 0.2, 0.5, 0.1, 0.2)
weights <- c(1.0, 2.5, 1.0, 1.0, 2.0, 3.0)
MeanQuadraticWeightedKappa(kappas, weights)
}
\seealso{
\code{\link{ScoreQuadraticWeightedKappa}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regression.R
\name{percent_bias}
\alias{percent_bias}
\title{Percent Bias}
\usage{
percent_bias(actual, predicted)
}
\arguments{
\item{actual}{The ground truth numeric vector.}

\item{predicted}{The predicted numeric vector, where each element in the vector
is a prediction for the corresponding element in \code{actual}.}
}
\description{
\code{percent_bias} computes the average amount that \code{actual} is greater
than \code{predicted} as a percentage of the absolute value of \code{actual}.
}
\details{
If a model is unbiased \code{percent_bias(actual, predicted)} should be close
to zero. Percent Bias is calculated by taking the average of
(\code{actual} - \code{predicted}) / \code{abs(actual)} across all observations.

\code{percent_bias} will give \code{-Inf}, \code{Inf}, or \code{NaN}, if any
elements of \code{actual} are \code{0}.
}
\examples{
actual <- c(1.1, 1.9, 3.0, 4.4, 5.0, 5.6)
predicted <- c(0.9, 1.8, 2.5, 4.5, 5.0, 6.2)
percent_bias(actual, predicted)
}
\seealso{
\code{\link{bias}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/binary_classification.R
\name{ll}
\alias{ll}
\title{Log Loss}
\usage{
ll(actual, predicted)
}
\arguments{
\item{actual}{The ground truth binary numeric vector containing 1 for the positive
class and 0 for the negative class.}

\item{predicted}{A numeric vector of predicted values, where the values correspond
to the probabilities that each observation in \code{actual}
belongs to the positive class}
}
\description{
\code{ll} computes the elementwise log loss between two numeric vectors.
}
\examples{
actual <- c(1, 1, 1, 0, 0, 0)
predicted <- c(0.9, 0.8, 0.4, 0.5, 0.3, 0.2)
ll(actual, predicted)
}
\seealso{
\code{\link{logLoss}}
}
